// -------------------------------------------------------------
// Factored BRDF
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;
float4 LightPos;
float4 EyePos;
float4 alpha;

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture MapP;
sampler SampP = sampler_state
{
    Texture = <MapP>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
texture MapQ;
sampler SampQ = sampler_state
{
    Texture = <MapQ>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// AvP[V璸_VF[_ɓnf[^
// -------------------------------------------------------------
struct VS_INPUT
{
    float4 Pos          : POSITION;
    float3 Normal       : NORMAL0;
    float2 Tex          : TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos          : POSITION;
    float4 v            : TEXCOORD0;
    float4 h            : TEXCOORD1;
    float4 w            : TEXCOORD2;
    float4 Intensity 	: COLOR0;
};

// -------------------------------------------------------------
// Wϊ
// -------------------------------------------------------------
float4 Q(float3 In, float3 B, float3 T, float3 N)
{
	float4 Out = (float4)0;
	
	// \ʍWn֕ϊ
	float3 v;
	v.x = dot(B,In);
	v.y = dot(T,In);
	v.z = dot(N,In);
	
	// Rp[^Qp[^ɕϊ
	float pv = 7.0f/8.0f;
	float ar = 1.0/(2.0*(1.000000001+v.z));

	if(0.7*(8.0f/7.0f)<ar){
		// OɏóAOɂ
		Out = 0;
	}else if(0.5*(8.0f/7.0f)<ar){
		// r͐`
		Out = (0.7*(8.0f/7.0f)-ar)/(0.2*(8.0f/7.0f));
	}else{
		Out = 1;
	}
	
	Out.x = pv * ar * v.x + 0.5;
	Out.y = pv * ar * v.y + 0.5;
	
	return Out;
}
// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS(VS_INPUT In)
{   
	VS_OUTPUT Out = (VS_OUTPUT)0;			 // o̓f[^
	
	// ʒuW
	Out.Pos = mul( In.Pos, mWVP );
	
	// \ʍWn̊xNg߂
	float3 N = In.Normal;					// @xNg
	float3 B = float3(0,1,0);				// ]@xNg
	float3 T = normalize(cross(N,B));		// ڃxNg
	B = cross(T,N);
	
	// KvȃxNgvZ
	float3 V = normalize(EyePos  -In.Pos.xyz);// _xNg
	float3 W = normalize(LightPos-In.Pos.xyz);// CgxNg
	float3 H = normalize(W+V);				// n[txNg

	// exNgeNX`W֕ϊ
	Out.v = Q(V, B,T,N);
	Out.w = Q(W, B,T,N);
	Out.h = Q(H, B,T,N);
	
	// Ƃ肠ACgɊւĔwʂ̏
	Out.Intensity = Out.w.a;

    return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 PS(VS_OUTPUT In) : COLOR
{   
    float4 v = tex2D( SampP, In.v );
    float4 h = tex2D( SampQ, In.h );
    float4 w = tex2D( SampP, In.w );
	
    return alpha * v * h * w * In.Intensity;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_1_1 PS();
    }
}

